package mockbrokerdriver

import (
	"query-service/internal/adapters/brokeradapter"

	"github.com/streadway/amqp"
)

// A Producer implements the producer interface (mock)
type Producer struct {
	broker *Driver

	// The exchange this producer is connected to
	exchange string
}

// PublishMessage publishes a message to the given queue (mock)
func (p *Producer) PublishMessage(body *[]byte, routingKey *string, headers *amqp.Table) {
	// Create the message
	msg := brokeradapter.Message{
		Headers: *headers,
		Body:    *body,
	}

	// Append the message to the list
	p.broker.Messages[*routingKey] = append(p.broker.Messages[*routingKey], msg)
}
